Subject: Re: [PATCH v2] net: netfilter: LLVMLinux: vlais-netfilter

From: Behan Webster <[email-masked]>
Date: Tue, 18 Mar 2014 07:47:21 -0700

On 03/18/14 02:41, David Laight wrote:
> From:  [email-masked]
>> From: Mark Charlebois <[email-masked]>
>>
>> Replaced non-standard C use of Variable Length Arrays In Structs (VLAIS) in
>> xt_repldata.h with a C99 compliant flexible array member and then calculated
>> offsets to the other struct members. These other members aren't referenced by
>> name in this code, however this patch maintains the same memory layout and
>> padding as was previously accomplished using VLAIS.
>>
>> Had the original structure been ordered differently, with the entries VLA at
>> the end, then it could have been a flexible member, and this patch would have
>> been a lot simpler. However since the data stored in this structure is
>> ultimately exported to userspace, the order of this structure can't be changed.
> Why not just remove the last element and allocate space for it after the
> structure?
Because that would still be employing VLAIS to solve the problem. The 
last element may be a zero-length array (a flexible member), not a VLA. 
Sadly both the last 2 elements in the struct need to be manually 
calculated, which is what we've done.

> That would reduce the complexity of the patch and the unreadability
> of the new code.
No one is claiming this patch is more readable, merely that it is C99 
compliant (though strictly speaking this patch is C89, C99 and C11 
compliant). We tried to use macros to make it more readable in previous 
patches. The consensus was that macros were bad.

> I realise that the alignment of type##_error is 'tricky' to determine.
That is what makes it "unreadable". :(

Behan

-- 
Behan Webster
[email-masked]